
#---------------------------------------------------------------------
sub Chk_BadWord
{
	return if( !$Cfg{'badWord'} );

	$Cfg{'badWordList'} =~ s/\r//g;
	my @BadWordList = split( /\n/, $Cfg{'badWordList'} );

	foreach( @BadWordList )
	{
		if( $_ !~ /^\s$/ && $CMD{'content'} =~ /$_/ )
		{
			&ErrMsg( "뿡 Ե <b>$_</b> ܾ ҷܾԴϴ." )
		}
	}
}


#---------------------------------------------------------------------
sub StrCut #( ڿ,  )
{
	my $i = 0;
	my $Sum = "";

	do
	{
		my $Te = substr( $_[0], $i++, 1 );
		$Sum .= $Te;
		$Sum .= substr( $_[0], $i++, 1 ) if( ord($Te) > 127 );
	}
	until( $i >= $_[1] );

	$Sum = substr( $Sum, 0, length($Sum)-2 ) if( length($Sum) > $_[1] );
	$_[0] = $Sum;
}


#---------------------------------------------------------------------
sub UrlEncode #( ڵҹڿ )
{
	$_[0] =~ s/'/&#39;/g;
	$_[0] =~ s/\|/&#124;/g;
	$_[0] =~ s/\r//g;

	if( !$CMD{'html'} )
	{
		$_[0] =~ s/</&lt;/g;
		$_[0] =~ s/>/&gt;/g;
		$_[0] =~ s/\n/<br>/g;
	}
}


#---------------------------------------------------------------------
sub UrlDecode #( ڵҹڿ )
{
	$_[0] =~ s/&#124;/\|/g;
	$_[0] =~ s/&#39;/'/g;

	if( !$Cont[$cHtml] )
	{
		$_[0] =~ s/<br>/\n/g;
		$_[0] =~ s/&#124;/\|/g;
		$_[0] =~ s/&#39;/'/g;
		$_[0] =~ s/&gt;/>/g;
		$_[0] =~ s/&lt;/</g;
	}
}


sub Prn_Button #( comment, url, img )
#*********************************************************************
# Խ ư 
#---------------------------------------------------------------------
{
	my $ImgWidth  = "width=$_[3]"  if( $_[3] );
	my $ImgHeight = "height=$_[4]" if( $_[4] );

	print " " x 4;
	print "<a href='$_[1]' onMouseOver=\"window.status=('$_[0]'); return true;\" onMouseOut=\"window.status=(''); return true;\">";
	print "<img src=$IMG_PATH/$_[2].gif border=0 $ImgWidth $ImgHeight></a>\n";
}


sub Prn_Notice
#*********************************************************************
#  
#---------------------------------------------------------------------
{
	if( $Cfg{'notice'} && $CMD{'act'} eq "")
	{
		printf "<table width='%s' border=0 cellspacing=0>\n", $_[0]? $_[0]: $Cfg{'tblWidth'};
		print "  <tr>\n";
		print "    <td align=center class=text>\n";
		print "$Cfg{'notice'}\n";
		print "    </td>\n";
		print "  </tr>\n";
		print "  <tr><td>&nbsp;</td></tr>\n";
		print "</table>\n\n";
	}
}


#====================
#*  ϱ
#---------------------------------------------------------------------
sub GetFileInfo #( /ϸ )
{
	my @giArray = stat( $_[0] );
	return $giArray[7];
}


sub GetFileType
#*********************************************************************
# ε  Ȯں  
#---------------------------------------------------------------------
{
	my $tType;

	if( $_[0] )
	{
		$tType = $_[0];
		$tType =~ s/^.+\.(.+)$/$1/gi;

		if   ( $tType =~ /htm/ ) { $tType = "html"; }
		elsif( $tType =~ /exe|com|bat/ ) { $tType = "exe"; }
		elsif( $tType =~ /zip|rar|ace|arj|gz|tar/ ) { $tType = "zip"; }
		elsif( $tType =~ /gif|pcx|tif|bmp|jpe*g/ ) { $tType = "image"; }
		elsif( $tType =~ /mid|wav|mp|ra|s3m|voc|mod|rol|ims/ ) { $tType = "sound"; }
		elsif( $tType =~ /txt|doc|hwp/ ) { $tType = "text"; }
		elsif( $tType =~ /cgi|pl|pm/ ) { $tType = "cgi"; }
		elsif( $tType =~ /mov|avi|rm|ram|mpg/ ) { $tType = "movie"; }
		else { $tType = "unknown"; }
	}

	return $tType;
}


#---------------------------------------------------------------------
sub GetFileSize
{
	my $tSize = -s "$DB_PATH/files/$_[0]";

	if   ( !$tSize            ){ $tSize  = "0 byte"; }
	elsif( $tSize < (2 << 10) ){ $tSize .= "bytes";  }
	elsif( $tSize < (2 << 20) ){ $tSize >>= 10; $tSize .= "KB"; }
	elsif( $tSize < (2 << 30) ){ $tSize >>= 20; $tSize .= "MB"; }
	else                       { $tSize >>= 30; $tSize .= "GB"; }

	return $tSize;
}



sub GetCookie
#*********************************************************************
#
#---------------------------------------------------------------------
{
	if( $ENV{'HTTP_COOKIE'} )
	{
		my @Arr = split( /; /, $ENV{'HTTP_COOKIE'} );

		foreach $TempStr( @Arr )
		{
			my( $Name, $Value ) = split(/=/, $TempStr);
			$Cookie{$Name} = $Value;
		}
	}
}


sub SetCookie
#*********************************************************************
#
#---------------------------------------------------------------------
{
	my( $NAME, $VALUE, $EXPIRE ) = @_;

	if( $NAME && $VALUE && $COOKIE{$NAME} ne $VALUE )
	{
		if( $EXPIRE )
		{
			$EXPIRE = 86400 * $EXPIRE + time;
			my($year, $mon, $mday, $hour, $min, $sec, $gmMonth, $gmWeek, $apm, $halfhour) = &GMTime( $EXPIRE );
			print "Set-Cookie: $NAME=$VALUE; expires=$gmWeek, $mday-$gmMonth-$year $hour:$min:$sec GMT;";
		}
		else { print "Set-Cookie: $NAME=$VALUE;"; }
		print "\n";
	}
}


sub GMTime
#*********************************************************************
#
#---------------------------------------------------------------------
{
	return  &_ConvertTime( gmtime($_[0]), $_[1] );
}


sub _ConvertTime
#*********************************************************************
#
#---------------------------------------------------------------------
{
	my( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst, $sw) = @_;
	my( $apm ) = "AM";
	my( $halfhour ) = $hour;

	$gmMonth = (qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec))[$mon];

	if( $sw ) { $gmWeek  = (qw(  ȭ    ))[$wday]; }
	else { $gmWeek  = (qw(Sun Mon Tue Wed Thu Fri Sat))[$wday]; }

	$year += 1900;
	$mon++;

	if( $halfhour > 12 )
	{
		$halfhour -= 12;
		$apm = "PM";
	}

	$halfhour = 12  if( !$halfhour );
	return  ($year, $mon, $mday, $hour, $min, $sec, $gmMonth, $gmWeek, $apm, $halfhour);
}


#---------------------------------------------------------------------
sub GetDate
{
	my( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst ) = localtime($_[0]);
	$mon++;
	$year += 1900;
	if(    $_[1] == 0 ){ return sprintf( "%04d/%02d/%02d,%02d:%02d:%02d", $year,$mon,$mday,$hour,$min,$sec ); }
	elsif( $_[1] == 1 ){ return sprintf( "%d %d %d %d %d", $year,$mon,$mday,$hour,$min ); }
	elsif( $_[1] == 2 ){ return sprintf( "%04d/%02d/%02d", $year,$mon,$mday ); }
	elsif( $_[1] == 3 ){ return sprintf( "%d %d %d", $year,$mon,$mday ); }
	elsif( $_[1] == 9 ){ return $wday };
}


sub Time2Date #( time, "option" )
#*********************************************************************
# (Sec) => ¥(year)
#---------------------------------------------------------------------
{
	my( $Sec, $Min, $Hour, $Day, $Month, $Year, $Week, $Yday, $Isdst ) = localtime( $_[0] );

	$Year += 1900;
	$Month++;
}


sub Chk_CpuTime #( opt )
{
	unless( $_[0] )
	{
		$StrTime = times;
	}
	else
	{
		my $EndTime = times;
		printf "<!-- CPU Time : %4.2f -->", $EndTime - $StrTime;
	}
}



#*********************************************************************
# ϸ 
#---------------------------------------------------------------------
sub SetSmiley
{
	my( $data );
	my( $count ) = 100;
	my( @Smiley ) = ( "̼","",";","Ǫ","","ȣȣ","","","ȣȣ","ħ","߲","ȭ","","޷","","","","","ȣ","","","","","ε","","","","ֶ","幵","","","","ȣȣȫ","Ͽ","β","¦","°","ù","","۵","Ȳ","","","ũ","","Ǫ","","Թ","ñ","","","","Ȳ","ﾦ","","½","","" );
	my( @MiniPic) = ( "ذ","","" );

	foreach $data( @Smiley )
	{
		$count++;
		$Smiley_Char .= "$data|";
		$Smiley_File{$data} = $count;
	}

	$count = 200;
	foreach $data( @MiniPic )
	{
		$count++;
		$MiniPic_Char .= "$data|";
		$MiniPic_File{$data} = $count;
	}

	chop( $Smiley_Char );
	chop( $MiniPic_Char );
}



sub ChkEmail
#*********************************************************************
#
#---------------------------------------------------------------------
{
	my $Te = "\\w|~|-|=|_";

	if( $_[0] =~ /^($Te)+@($Te)+(\.($Te)+)+$/i ) { return 1; }
	else { return 0; }
}


sub ChkUrl
#*********************************************************************
#
#---------------------------------------------------------------------
{
	my $Te = "\\w|\\/|~|-|=|_|@";

	if( $_[0] =~ /^((http:\/\/)($Te)+(\.($Te)+)+)$/i ) { return 1; }
	else { return 0; }
}


#*********************************************************************
# ¥ īƮ
# =============
#   0 ~ 29  (30byte) header
#  30 ~ 31  ( 2byte) start year
#  32 ~ 35  ( 4byte) start time funciton
#  36 ~ 39  ( 4byte)  Ӽ
#  40 ~ 43  ( 4byte) ְ Ӽ
#  44 ~ 139 ( 4byte) ð  (1 ~ 24)
# 140 ~ 195 ( 4byte) Ϻ  (1 ~ 7)
# 196 ~ 235 ( 4byte) OS  (1 ~ 10)
# 236 ~ 275 ( 4byte)   (1 ~ 10 )
# 276 ~
#---------------------------------------------------------------------
sub AddCount
{
	my $Today  = &GetDate(time);
	my $tYear  = substr( $Today, 0, 4 );
	my $tMonth = substr( $Today, 5, 2 );
	my $tDay   = substr( $Today, 8, 2 );
	my $DFile  = "$DB_PATH/count.dat";
	my $Header = "gima's Date-Count file 1.00". chr(27);

	my( $Te, $T1, $T2, $Offset, $StrYear, $Rate, $TotRate, $MaxRate );

	fOpen( FP1, "$DFile", "b+r" );

	# ¥ īƮ
	#---------------
	$StrYear = &fGet( FP1, 30, 2, "S" );
	$Offset = (($tYear-$StrYear)*372 + ($tMonth-1)*31 + $tDay) * 4 + 276;
	$Rate = &fGet( FP1, $Offset, 4, "L" );
	&fPut( FP1, $Offset, ++$Rate, "L" );

	#  īƮ
	#---------------
	$Te = &fGet( FP1, 36, 4, "L" );
	&fPut( FP1, 36, ++$Te, "L" );

	# ְ īƮ
	#---------------
	$MaxRate = &fGet( FP1, 40, 4, "L" );
	&fPut( FP1, 40, $Rate, "L" ) if( $Rate > $MaxRate );

	# ð īƮ
	#---------------
	$Te = substr( $Today, 11,2 );
	$T1 = $Te * 4 + 44;
	$T2 = fGet( FP1, $T1, 4, "L" );
	fPut( FP1, $T1, ++$T2, "L" );

	# Ϻ īƮ
	#---------------
	$Te = &GetDate( time, 9 );
	$T1 = $Te * 4 + 140;
	$T2 = fGet( FP1, $T1, 4, "L" );
	fPut( FP1, $T1, ++$T2, "L" );

    $Te = $ENV{'HTTP_USER_AGENT'};

	# OS īƮ
	#---------------
	if   ( $Te =~ /95/     ) { $T1 = 0; }
	elsif( $Te =~ /98/     ) { $T1 = 1; }
	elsif( $Te =~ /NT 5.0/ ) { $T1 = 2; }
	elsif( $Te =~ /NT/     ) { $T1 = 3; }
	elsif( $Te =~ /Linux/i ) { $T1 = 4; }
	elsif( $Te =~ /SunOS/i ) { $T1 = 5; }
	elsif( $Te =~ /Macintosh/i  ) { $T1 = 6; }
	else { $T1 = 7; }

	if( $T1 == 7 )
	{
		open( fp2, ">>$DB_PATH/etc.dat" );
		flock( fp2, 2 ) if( $OS );
		print fp2 "[OS] $Te\n";
		close( fp2 );
		flock( fp2, 8 ) if( $OS );
	}

	$T1 = $T1 * 4 + 196;
	$T2 = fGet( FP1, $T1, 4, "L" );
	fPut( FP1, $T1, ++$T2, "L" );

	#  īƮ
	#-------------------
	if   ( $Te =~ /MSIE 4.0/   ) { $T1 = 0; }
	elsif( $Te =~ /MSIE 5.0/   ) { $T1 = 1; }
	elsif( $Te =~ /MSIE 5.5/   ) { $T1 = 2; }
	elsif( $Te =~ /MSIE/       ) { $T1 = 3; }
	elsif( $Te =~ /Mozilla/i   ) { $T1 = 4; }
	else { $T1 = 5; }

	if( $T1 == 5 )
	{
		open( fp2, ">>$DB_PATH/etc.dat" );
		flock( fp2, 2 ) if( $OS );
		print fp2 "[OS] $Te\n";
		close( fp2 );
		flock( fp2, 8 ) if( $OS );
	}

	$T1 = $T1 * 4 + 236;
	$T2 = fGet( FP1, $T1, 4, "L" );
	fPut( FP1, $T1, ++$T2, "L" );

	fClose( FP1, 1 );
}


#---------------------------------------------------------------------
sub GetCount
{
	my $Today  = &GetDate(time);
	my $tYear  = substr( $Today, 0, 4 );
	my $tMonth = substr( $Today, 5, 2 );
	my $tDay   = substr( $Today, 8, 2 );
	my $DFile  = "$DB_PATH/count.dat";
	my $Header = "gima's Date-Count file 1.00".chr(27)."  ";

	my( $Te, $T1, $T2, $Offset, $StrYear, $Rate, $TotRate, $MaxRate );

	fOpen( fp1, "$DFile", "b+r" );

	#  īƮ
	#---------------
	$T1 = fGet( fp1, 36, 4, "L" );

	# ¥ īƮ
	#---------------
	$StrYear = fGet( fp1, 30, 2, "S" );
	$Offset = (($tYear-$StrYear)*372 + ($tMonth-1)*31 + $tDay) * 4 + 276;
	$T2 = fGet( fp1, $Offset, 4, "L" );

	fClose( fp1 );

	return $T1, $T2;
}


#---------------------------------------------------------------------
sub ViewCount
{
	require "$LIB_PATH/bcount.cgi";

	&HtmlHead;

	if   ( $CMD{'sact'} eq ""     ){ &View_Month; }
	elsif( $CMD{'sact'} eq "time" ){ &View_Time;  }
	elsif( $CMD{'sact'} eq "week" ){ &View_Week;  }
	elsif( $CMD{'sact'} eq "os"   ){ &View_OS;    }
	elsif( $CMD{'sact'} eq "bros" ){ &View_Bros;  }
	else { &View_Month; }

	&HtmlTail;
}



sub SendMail
#*********************************************************************
#
#---------------------------------------------------------------------
{
	my( $FromName, $FromMail, $ToName, $ToMail ) = @_;

	return if( !$FromMail || !$ToMail );

	$ToMail = "$ToName<$ToMail>" if( $ToName );
	$FromMail = "$FromName<$FromMail>" if( $FromName );

	if( open( MAIL, "|$Cfg{'mailProg'}" ) )
	{
		print MAIL "From: $FromMail\n";
		print MAIL "To: $ToMail\n";
		print MAIL "Subject: $CMD{'subject'}\n";
		print MAIL "Content-Type: text/html; charset=euc-kr\n";

		print MAIL "<html>\n";
		print MAIL "<body>\n";
		print MAIL "$FromName '$Cfg{'bodTitle'}( $CMD{'db'} )' Խǿ  Դϴ.<br>\n";
		print MAIL "<hr size=1>\n";
		print MAIL "$CMD{'content'}\n";
		print MAIL "</body>\n";
		print MAIL "</html>\n";
		close( MAIL );
	}
}


#---------------------------------------------------------------------
return 1;
