#!/usr/bin/perl
#********************************************************************
# 纸 1.0
#--------------------------------------------------------------------
umask(070);

require './system.cgi';
&GetPath;

push @INC, $LIB_PATH;
use Fcntl ':flock';

require 'gidb.cgi';
require 'gilib.cgi';
require 'common.cgi';

&Chk_CpuTime( 0 );
&GetParse;
&Init;

if   ( $CMD{'act'} eq ""        ){ &List;    }
elsif( $CMD{'act'} eq "read"    ){ &Read;    }
elsif( $CMD{'act'} eq "pread"   ){ &Read;    }
elsif( $CMD{'act'} eq "edit"    ){ &Write;   }
elsif( $CMD{'act'} eq "write"   ){ &Write;   }
elsif( $CMD{'act'} eq "reply"   ){ &Write;   }
elsif( $CMD{'act'} eq "del"     ){ &Delete;  }
elsif( $CMD{'act'} eq "editIn"  ){ &EditIn;  }
elsif( $CMD{'act'} eq "replyIn" ){ &ReplyIn; }
elsif( $CMD{'act'} eq "writeIn" ){ &WriteIn; }
elsif( $CMD{'act'} eq "search"  ){ &Search;  }
elsif( $CMD{'act'} eq "down"    ){ &DownLoad;  }
elsif( $CMD{'act'} eq "cntview" ){ &ViewCount; }
elsif( $CMD{'act'} eq "delinfo" ){ &Get_DelInfo; }
else { &ErrMsg( "߸ ĶԴϴ." ) }

&Chk_CpuTime( 1 ) if( $CMD{'act'} ne "down" );
exit;



sub Init
#*********************************************************************
# ʱȭ
#---------------------------------------------------------------------
{
	print "location: ./dbmake.cgi\n\n" unless( $CMD{'db'} );

	$CMD{'page'} = 1 unless( $CMD{'page'} );
	$CMD{'pw'}   = &MakePW( $CMD{'orgpw'} ) if( $CMD{'orgpw'} );

	$DB_IMG  = "$DB_IMG/$CMD{'db'}";
	$DB_PATH = "$DB_ROOT/$CMD{'db'}";

	$cDepth = 0;
	$cPass  = 1;
	$cName  = 2;
	$cMail  = 3;
	$cHome  = 4;
	$cSubj  = 5;
	$cDate  = 6;
	$cFace  = 7;
	$cHtml  = 8;
	$cLink  = 9;
	$cSmil  = 10;
	$cFile  = 11;
	$cImage = 12;
	$cIP    = 13;
	$cAgent = 14;
	$cView  = 21;
	$cDown  = 22;
	$cInt1  = 23;
	$cInt2  = 24;

	&ReadConfig;
	&ChkConfig;

	&SetSmiley if( $Cfg{'smiley'} );
	&SetCookie( "$CMD{'db'}_cnt", 1 ) if( !$CMD{'act'} );

#	&ErrMsg( "db ̸ Ǿ  ʽϴ." ) unless( $CMD{'db'} );
	&ErrMsg( "$CMD{'db'}  ʴ dbԴϴ." ) if( !-d $DB_PATH );

#	mkdir( $DB_ROOT, 0777 ) unless( -d $DB_ROOT );

	$Cfg{'skin'} = "_default" unless( $Cfg{'skin'} );
	$Cfg{'skin'} = "_default" unless( -d "$SKIN_ROOT/$Cfg{'skin'}" );

	$SKIN_IMG  = "$SKIN_IMG/$Cfg{'skin'}";
	$SKIN_PATH = "$SKIN_ROOT/$Cfg{'skin'}";

	require "$SKIN_PATH/$Cfg{'skin'}.cgi";

	&Skin_Config;
	&Get_TotalCont;
}



sub List
#*********************************************************************
# Ϻ
#---------------------------------------------------------------------
{
	if( $CMD{'act'} ne "read" )
	{
		&HtmlHead;
		&Prn_BoardTitle;
	}

	if( $CMD{'act'} eq "" )
	{
		&GetCookie;
		&AddCount if( !$Cookie{$CMD{'db'}.'_cnt'} );
	}

	if( $CMD{'act'} eq "search" ) { &GetRange4Search; }
	elsif( $GetRangeOpt ) { &GetRange4ZeroDep; &GetDepth; }
	else { &GetRange; &GetDepth; }

	local( $TotalPage ) = int( ($TotalCont - 1) / $Cfg{'pageLine'} ) + 1;
	local( $ListCount ) = 0;
	local( $TotalCnt, $TodayCnt ) = &GetCount;

	&Skin_List;
	&HtmlLogo;
	&HtmlTail;
}



sub Read
#*********************************************************************
# 
#---------------------------------------------------------------------
{
	&GetContent( $CMD{'num'} );
	&ChgContent( $Content );

	local( $PrevNum, $NextNum ) = &GetPrevNextNum;

	&HtmlHead;
	&Prn_BoardTitle;
	&Skin_Read;

	&Add_InfoCount( $CMD{'num'} );

	&List     if(  $Cfg{'readList'} );
	&HtmlLogo if( !$Cfg{'readList'} );
	&HtmlTail if( !$Cfg{'readList'} );
}



sub Delete
#*********************************************************************
# 
#---------------------------------------------------------------------
{
	&Chk_Password( "ۻ" );
	&GetContent( $CMD{'num'}, 1 );

	fOpen( FP1, "$DB_PATH/index.dat", "br" );
	my $Te = ord( fGet( FP1, $CMD{'num'} * 5 + 39, 1, "" ));
	close( FP1 );

	&ErrMsg( " ִ    ϴ." ) if( $Te > $Cont[$cDepth] );
	&Del_BinFile( $CMD{'num'} );

	unlink( "$DB_PATH/files/$Cont[$cFile]" ) if( $Cont[$cFile] );
	unlink( "$DB_PATH/image/$Cont[$cImage]" ) if( $Cont[$cImage] );

	&Java_GoNext;
}



sub Search
#*********************************************************************
# ˻
#---------------------------------------------------------------------
{
	&ErrMsg( "˻  ʾҽϴ." ) unless( $CMD{'key'} );
	&ErrMsg( "˻  ʾҽϴ." ) unless( $CMD{'word'} );

	$SearchWord = $CMD{'word'};
	$SearchWord =~ s/\\/\\\\/g;
	$SearchWord =~ s/\^/\\\^/g;
	$SearchWord =~ s/\$/\\\$/g;
	$SearchWord =~ s/\(/\\(/g;
	$SearchWord =~ s/\)/\\)/g;
	$SearchWord =~ s/\./\\./g;
	$SearchWord =~ s/\*/\\*/g;

	&List;
}



sub DownLoad
#*********************************************************************
# ٿε
#---------------------------------------------------------------------
{
	&GetContent( $CMD{'num'}, 1 );

	if( $Cont[$cFile] && -e "$DB_PATH/files/$Cont[$cFile]" )
	{
		my $tFile;
		($tFile = $Cont[$cFile]) =~ s{^.+/(.+)$}{$1}g;

		print "Content-type: application/octet-stream\n";
		print "Content-disposition: attachment; filename=$tFile\n";
		print "Content-Transfer-Encoding: binary\n\n";

		open( FP1, "$DB_PATH/files/$Cont[$cFile]" );
		binmode( FP1 );
		binmode( STDOUT );
		binmode( STDERR );
		print <FP1>;
		close FP1;

		&Add_InfoCount( $CMD{'num'}, 1 );
	}
	else { &ErrMsg( " ʴ Դϴ." ); }
}



sub Write
#*********************************************************************
# ۾
#---------------------------------------------------------------------
{
	&ErrMsg( "īƮ  Ǿ  ʽϴ." ) unless( -w "$DB_PATH/count.dat" );
	&ErrMsg( "ε  Ǿ  ʽϴ." ) unless( -w "$DB_PATH/index.dat" );
	&ErrMsg( "  Ǿ  ʽϴ." ) unless( -w "$DB_PATH/content.dat" );

	&Chk_AdminPW ( "۾"   ) if( $CMD{'act'} eq "write" && $Cfg{'writePerm'} );
	&Chk_AdminPW ( "ϱ" ) if( $CMD{'act'} eq "reply" && $Cfg{'replyPerm'} );
	&Chk_Password( "ۼ"   ) if( $CMD{'act'} eq "edit" );

	&GetCookie;
	&GetContent( $CMD{'num'} ) if( $CMD{'act'} ne "write" );

	local( $vName, $vMail, $vHome, $vSubj, $vCont, $vPass );
	local( $vFace, $vLink, $vHtml, $vSmil, $vFile, $vImage );

	$vName = "value='$Cookie{'name'}'";
	$vMail = "value='$Cookie{'mail'}'";
	$vHome = "value='$Cookie{'home'}'";
	$vFace = "$Cookie{'face'}";

	if( $CMD{'act'} eq "write" )
	{
		$vCont = $Cfg{'defCont'} if( $Cfg{'defCont'} );
	}
	else
	{
		&UrlDecode( $Cont[$cName] );
		&UrlDecode( $Cont[$cSubj] );
		&UrlDecode( $Content );
	}

	if( $CMD{'act'} eq "reply" )
	{
		$vSubj = "value='$Cfg{'reSubj'}$Cont[$cSubj]'";
		$Cfg{'replyShow'} = 2 if( $Cont[$cHtml] );

		if( $Cfg{'replyShow'} == 1 )
		{
			$Content = "$Cfg{'reText'}$Content";
			$Content =~ s/\n/\n$Cfg{'reText'}/g;
			$vCont = "$Cont[$cName]$Cfg{'reHead'}\n$Content";
		}
		elsif( $Cfg{'replyShow'} == 2 )
		{
			$vCont = $Content;
		}
	}

	if( $CMD{'act'} eq "edit" )
	{
		$vName = "value='$Cont[$cName]'";
		$vMail = "value='$Cont[$cMail]'";
		$vHome = "value='$Cont[$cHome]'";
		$vSubj = "value='$Cont[$cSubj]'";
		$vFile = "value='$Cont[$cFile]'";
		$vImage= "value='$Cont[$cImage]'";
		$vFace = "$Cont[$cFace]";
		$vCont = "$Content";
		$vPass = "newpw";
		$vHtml = $Cont[$cHtml] ? "checked" : "";
		$vLink = $Cont[$cLink] ? "checked" : "";
		$vSmil = $Cont[$cSmil] ? "checked" : "";
	}
	else
	{
		$vHtml = "";
		$vLink = "checked";
		$vSmil = "checked";
		$vPass = "orgpw";
	}

	&HtmlHead;
	&Prn_BoardTitle;

	printf "<form method=post name=inputform action=$BOARD_CGI %s>\n", ($Cfg{'inputFile'} || $Cfg{'inputImg'} )? "enctype=multipart/form-data": "";
	print  "<input type=hidden name=db   value='$CMD{'db'}'>\n";
	print  "<input type=hidden name=act  value='$CMD{'act'}In'>\n";
	print  "<input type=hidden name=num  value='$CMD{'num'}'>\n";
	print  "<input type=hidden name=page value='$CMD{'page'}'>\n";

	if( $CMD{'act'} eq "edit" )
	{
		print "<input type=hidden name=pw    value='$Cont[$cPass]'>\n";
		print "<input type=hidden name=depth value='$Cont[$cDepth]'>\n";
		print "<input type=hidden name=vicnt value='$Cont[$cView]'>\n";
		print "<input type=hidden name=dncnt value='$Cont[$cDown]'>\n";
		print "<input type=hidden name=fileX value='$Cont[$cFile]'>\n";
		print "<input type=hidden name=imgX  value='$Cont[$cImage]'>\n";
		print "<input type=hidden name=int1  value='$Cont[$cInt1]'>\n";
	}

	printf "<input type=hidden name=depth value=%d>\n", $Cont[$cDepth]+1 if( $CMD{'act'} eq "reply" );
	print  "\n";

	&Skin_Write;
	&HtmlLogo;
	&HtmlTail;
}


sub WriteIn
#*********************************************************************
# ۾ 
#---------------------------------------------------------------------
{
	my( $Infomation );

	$CMD{'depth'} = 0;
	$CMD{'vicnt'} = 0;
	$CMD{'dncnt'} = 0;
	$CMD{'pw'} = &MakePW( $CMD{'orgpw'} ) if( $CMD{'orgpw'} );

	&Chk_Content;
	&Add_Content( $Infomation );
	&Add_BinFile( $Infomation, $CMD{'content'} );
	&SendMail( $CMD{'name'}, $CMD{'email'}, $Cfg{'adminName'}, $Cfg{'adminMail'} ) if( $Cfg{'writeMail'} );
	&Java_GoNext;
}


sub EditIn
#*********************************************************************
#  
#---------------------------------------------------------------------
{
	my( $Infomation );

	unlink "$DB_PATH/files/$CMD{'fileX'}" if( $CMD{'fileX'} && $CMD{'file'} );
	unlink "$DB_PATH/image/$CMD{'imgX'}"  if( $CMD{'imgX'}  && $CMD{'image'} );

	$CMD{'pw'} = &MakePW( $CMD{'newpw'} ) if( $CMD{'newpw'} );

	&Chk_Content;

	local( $Skip_File, $Skip_Image );

	if( !$CMD{'file'} && $CMD{'fileX'} )
	{
		$CMD{'file'} = $CMD{'fileX'};
		$Skip_File = 1;
	}

	if( !$CMD{'image'} && $CMD{'imgX'} )
	{
		$CMD{'image'} = $CMD{'imgX'};
		$Skip_Image = 1;
	}

	&Add_Content( $Infomation );
	&Edit_BinFile( $Infomation, $CMD{'content'}, $CMD{'num'} );
	&SendMail( $CMD{'name'}, $CMD{'email'}, $Cfg{'adminName'}, $Cfg{'adminMail'} ) if( $Cfg{'writeMail'} );

	if( $GetRangeOpt ) { &Java_GoNext; }
	else { &Java_GoNext( "$BOARD_CGI?db=$CMD{'db'}&act=read&page=$CMD{'page'}&num=$CMD{'num'}" ); }
}


sub ReplyIn
#*********************************************************************
#  
#---------------------------------------------------------------------
{
	my( $Infomation );

	$CMD{'vicnt'} = 0;  
	$CMD{'dncnt'} = 0;
	$CMD{'pw'} = &MakePW( $CMD{'orgpw'} ) if( $CMD{'orgpw'} );

	&Chk_Content;
	&Add_Content( $Infomation );
	&Ins_BinFile( $Infomation, $CMD{'content'}, $CMD{'num'} );

	&GetContent( $CMD{'num'}, 1 );
	&SendMail( $CMD{'name'}, $CMD{'email'}, $Cfg{'adminName'}, $Cfg{'adminMail'} ) if( $Cfg{'writeMail'} );
	&SendMail( $CMD{'name'}, $CMD{'email'}, $Cont[$cName], $Cont[$cMail] ) if( $Cfg{'replyMail'} );

	&Java_GoNext;
}



sub Chk_Content
#*********************************************************************
# ϱ  üũϱ
#---------------------------------------------------------------------
{
	$CMD{'home'}  = "" if( $CMD{'home'}  =~ /^\s*$/ );
	$CMD{'email'} = "" if( $CMD{'email'} =~ /^\s*$/ );
	$CMD{'email'} = "" if( $CMD{'email'} eq "̸" );
	$CMD{'name'}  = "" if( $CMD{'name'}  eq "̸"   );

	&ErrMsg( "߸ EMAILԴϴ."     ) if( $CMD{'email'}   && !&ChkEmail( $CMD{'email'} ));
	&ErrMsg( "߸ URLԴϴ."       ) if( $CMD{'home'}    && !&ChkUrl  ( $CMD{'home'}  ));
	&ErrMsg( "E-MAIL ."      ) if( $Cfg{'absMail'} && $CMD{'email'}   =~ /^\s*$/ );
	&ErrMsg( "Ȩ ."    ) if( $Cfg{'absHome'} && $CMD{'home'}    =~ /^\s*$/ );
	&ErrMsg( "̸ ."        ) if( $Cfg{'absName'} && $CMD{'name'}    =~ /^\s*$/ );
	&ErrMsg( "÷ ϸ ." ) if( $Cfg{'absFile'} && $CMD{'file'}    =~ /^\s*$/ );
	&ErrMsg( "׸ ϸ ." ) if( $Cfg{'absImg'}  && $CMD{'image'}   =~ /^\s*$/ );
	&ErrMsg( " ."        ) if(!$Cfg{'noSubj'}  && $CMD{'subject'} =~ /^\s*$/ );

	&ErrMsg( " ." ) if( $CMD{'content'} eq $Cfg{'defCont'} );
	&ErrMsg( " ." ) if( $CMD{'content'} =~ /^\s*$/ );

	&ErrMsg( "ּ(&lt!--) Ե    ϴ." ) if( $CMD{'html'} && $CMD{'content'} =~ /<!--/ );
	&ErrMsg( "ڹٽũƮ Ե    ϴ." ) if( $CMD{'html'} && $CMD{'content'} =~ /<.*?script.*?>/i );
	&ErrMsg( " ʹ մϴ.<br> ̻̿ ̽ ־ּ." ) if( $Cfg{'contSpc'} && $CMD{'content'} =~ /.[^ ]{$Cfg{'contSpc'}}/ );

	&ErrMsg( "̸ Ưڸ   ϴ." ) if( $CMD{'name'} =~ /[!-\-\/:-@\[-\`{-~]/ );
	&ErrMsg( "̸ .gif .jpg .jpeg ϸ մϴ." ) if( $CMD{'image'} && ($CMD{'image'} !~ /\.gif$/ && $CMD{'image'} !~ /\.jpe*g$/ ));
	&ErrMsg( "  ʽϴ." ) if( $CMD{'file'} && !$CMD{'file_bin'} || $CMD{'image'} && !$CMD{'image_bin'} );

	&ErrMsg( "̸ ʹ ׿.<br>ְ $Cfg{'nameMax'}byte մϴ." ) if( $Cfg{'nameMax'} && $Cfg{'nameMax'} < length($CMD{'name'}) );
	&ErrMsg( " ʹ ׿.<br>ְ $Cfg{'subjMax'}byte մϴ." ) if( $Cfg{'subjMax'} && $Cfg{'subjMax'} < length($CMD{'subject'}) );
	&ErrMsg( " ʹ ׿.<br>ְ $Cfg{'contMax'}byte մϴ." ) if( $Cfg{'contMax'} && $Cfg{'contMax'} < length($CMD{'content'}) );

	&ErrMsg( " ε $Cfg{'fileLimit'}kbyte մϴ."    ) if( $Cfg{'fileLimit'} && (length($CMD{'file_bin'})  >> 10) > $Cfg{'fileLimit'} );
	&ErrMsg( "̸ ε $Cfg{'imgLimit'}kbyte մϴ." ) if( $Cfg{'imgLimit'}  && (length($CMD{'image_bin'}) >> 10) > $Cfg{'imgLimit'} );

	&Chk_BadWord;

	if( $CMD{'act'} ne "replyIn" )
	{
		&SetCookie( "name", $CMD{'name'} , 30 );
		&SetCookie( "mail", $CMD{'email'}, 30 );
		&SetCookie( "home", $CMD{'home'} , 30 );
		&SetCookie( "face", $CMD{'face'} , 30 );
	}

	&UrlEncode( $CMD{'name'} );
	&UrlEncode( $CMD{'subject'} );
	&UrlEncode( $CMD{'content'} );

	$CMD{'file'}  =~ s/'//g if( $CMD{'file'} );
	$CMD{'image'} =~ s/'//g if( $CMD{'image'} );
}


#---------------------------------------------------------------------
sub Add_Content
{
	my $Today = &GetDate(time);

	&Save_Upload if( $CMD{'file'} || $CMD{'image'} );

	$_[0]  = pack( "I10", $CMD{'vicnt'}, $CMD{'dncnt'}, $CMD{'int1'}, 0, 0, 0, 0, 0, 0, 0 );
	$_[0] .= "|$CMD{'pw'}|$CMD{'name'}|$CMD{'email'}|$CMD{'home'}|$CMD{'subject'}|$Today";
	$_[0] .= "|$CMD{'face'}|$CMD{'html'}|$CMD{'autolink'}|$CMD{'smiley'}|$CMD{'file'}|$CMD{'image'}";
	$_[0] .= "|$ENV{'REMOTE_ADDR'}|$ENV{'HTTP_USER_AGENT'}||||||";
}



sub Save_Upload
#*********************************************************************
# ε  ϱ
#---------------------------------------------------------------------
{
	$CMD{'num'} = &Get_TotalCont if( $CMD{'act'} eq "writeIn" );

	if( $CMD{'file'} && !$Skip_File )
	{
		chop( $CMD{'file_bin'} );
		chop( $CMD{'file_bin'} );

		$CMD{'file'} = &SearchDir( "files", $CMD{'file'} );

		fOpen( FP1, "$DB_PATH/files/$CMD{'file'}", "bw" );
		print FP1 $CMD{'file_bin'};
		fClose( FP1, 1 );
	}

	if( $CMD{'image'} && !$Skip_Image )
	{
		chop( $CMD{'image_bin'} );
		chop( $CMD{'image_bin'} );

		$CMD{'image'} = &SearchDir( "image", $CMD{'image'} );

		fOpen( FP1, "$DB_PATH/image/$CMD{'image'}", "bw" );
		print FP1 $CMD{'image_bin'};
		fClose( FP1, 1 );
	}
}


#---------------------------------------------------------------------
sub SearchDir #( dir, file )
{
	return "$_[1]" unless( -e "$DB_PATH/$_[0]/$_[1]" );

	my $Num = 0;
	while()
	{
		$Num++;
		if( -e "$DB_PATH/$_[0]/$Num" )
		{
			last unless( -e "$DB_PATH/$_[0]/$Num/$_[1]" );
		}
		else
		{
			mkdir( "$DB_PATH/$_[0]/$Num", 0777 );
			last;
		}
	}
	return "$Num/$_[1]";
}



sub GetPage
#*********************************************************************
#   
#---------------------------------------------------------------------
{
	my $StrPage = 1;
	my $EndPage = int( ($TotalCont-1) / $Cfg{'pageLine'} ) + 1;
	return $StrPage, $EndPage;
}


sub GetRange
#*********************************************************************
# ;  Խùȣ @Index 
#---------------------------------------------------------------------
{
	my $Cnt = 0;
	my $StrNum = $TotalCont - ( ($CMD{'page'}-1) * $Cfg{'pageLine'} );
	my $EndNum = $StrNum - $Cfg{'pageLine'} + 1;
	   $EndNum = 1 if( $EndNum < 1 );

	if( $CMD{'act'} eq "read" )
	{
		$StrNum  = $CMD{'num'} + int(($Cfg{'readList'}-1) / 2);
		$EndNum  = $CMD{'num'} - int(($Cfg{'readList'}-1) / 2) - ($Cfg{'readList'}-1) % 2;
		$EndNum += $TotalCont - $StrNum if( $StrNum > $TotalCont );
		$StrNum += 1 - $EndNum if( $EndNum < 1 );
		$StrNum  = $TotalCont if( $StrNum > $TotalCont );
		$EndNum  = 1 if( $EndNum < 1 );
	}
	for( my $i=$StrNum; $i>=$EndNum; $i-- ) { $Index[$Cnt++] = $i; }
}


#---------------------------------------------------------------------
sub GetRange4ZeroDep
{
	my( $SkipCnt, $IndexCnt ) = ( 0, 0 );
	my( $ReplyItem, $ReplyCnt ) = ( 0, 0 );
	my( $tStr, $tEnd ) = ( $TotalCont, 1 );

	my $Flag = 0;
	my $SkipMax = ($CMD{'page'} - 1) * $Cfg{'pageLine'};

	fOpen( fp1, "$DB_PATH/index.dat", "br" );

	for( my $i=$TotalCont; $i>=0; $i-- )
	{
		unless( ord( fGet( fp1, $i * 5 + 44, 1, "" )))
		{
			$ReplyTot[$ReplyItem++] = $ReplyCnt if( $Flag );
			$ReplyCnt = 0;
			$Flag = 1;
			$SkipCnt++;

			if( $SkipCnt > $SkipMax )
			{
				$tStr = $i unless( $IndexCnt );
				$tEnd = $i;
				last if( ++$IndexCnt >= $Cfg{'pageLine'}+1 );
			}
		}
		else { $ReplyCnt++; }
	}
	close( fp1 );

	$TotalCont = &Get_TotalZero;
	$tEnd++;
	for( $i=$tStr; $i>=$tEnd; $i-- ) { $Index[$tStr-$i] = $i; }
}


#---------------------------------------------------------------------
sub GetRange4Search
{
	my( $SkipCnt )= 0;
	my( $IndexCnt )= 0;
	my( $Sw, $SkipMax );

	$CMD{'spage'} = 1 unless( $CMD{'spage'} );
	$SkipMax = ($CMD{'spage'} - 1) * $Cfg{'pageLine'};

	for( my $i=$TotalCont; $i>=1; $i-- )
	{
		my $Sw = 0;

		&GetContent( $i, (($CMD{'key'} & 4) == 4)? 0 : 1 );

		$Sw = 1 if( ($CMD{'key'} & 1) == 1 && $Cont[$cName] =~ /$SearchWord/i );
		$Sw = 1 if( ($CMD{'key'} & 2) == 2 && $Cont[$cSubj] =~ /$SearchWord/i );
		$Sw = 1 if( ($CMD{'key'} & 4) == 4 && $Content =~ /$SearchWord/i );
		if( $Sw )
		{
			$SkipCnt++;
			if( $SkipCnt > $SkipMax )
			{
				$Index[$IndexCnt++] = $i;
				last if( $IndexCnt >= $Cfg{'pageLine'} );
			}
		}
	}
	&ErrMsg( "̻ ˻ Խù ϴ." ) unless( $IndexCnt );
}



sub GetDepth
#*********************************************************************
#     о
#---------------------------------------------------------------------
{
	return if( $CMD{'act'} eq "search" );

	my $Offset = $Index[0] * 5 + 44;
	my $Limit = $Index[0] - $Index[$#Index] + 1;

	fOpen( FP1, "$DB_PATH/index.dat", "br" );

	do
	{
		push @Depth, ord( fGet( FP1, $Offset, 1, "" ));
		$Offset -= 5;
	}
	until( !$Depth[$#Depth] && $#Depth > $Limit || $Offset < 48 );

	close( FP1 );
}



sub GetContent #( Խùȣ, ɼ )
#*********************************************************************
# Խù  о
#---------------------------------------------------------------------
{
	my( $Te, $Info );

	fOpen( FP1, "$DB_PATH/index.dat", "br" );
	my $Offset = fGet( FP1, $_[0] * 5 + 40, 4, "L" );
	my $Depth  = fGet( FP1, -1, 1, "" );
	close( FP1 );

	fOpen( FP2, "$DB_PATH/content.dat", "br" );
	seek ( FP2, $Offset, 0 );
	read ( FP2, $Te, 4 ); read( FP2, $Info, unpack( "I", $Te ));
	read ( FP2, $Te, 4 ); read( FP2, $Content, unpack( "I", $Te )) unless( $_[1] );
	close( FP2 );

	@Cont = split( /\|/, substr( $Info, 40, length($Info) - 40 ));
	$Cont[$cDepth] = ord( $Depth );

	for( 0..9 ) { $Cont[21 + $_] = unpack( "I", substr( $Info, $_ * 4, 4 )); }

	if( $CMD{'act'} eq "" || $CMD{'act'} =~ /read$/ )
	{
		&StrCut( $Cont[$cName], $Cfg{'nameCut'} ) if( $Cfg{'nameCut'} );
		&StrCut( $Cont[$cSubj], $Cfg{'subjCut'} ) if( $Cfg{'subjCut'} );
		&StrCut( $Content     , $Cfg{'contCut'} ) if( $Cfg{'contCut'} );
	}
}


sub GetColor
#*********************************************************************
#  RGB 
#---------------------------------------------------------------------
{
	if( $Cfg{'colMode'} ) #- ׶̼
	{
		if( $_[0] eq "" ) { return &SetRGB; }
		else { return &SetRGB( $_[0] ); }
	}
	else #- Ȧ¦
	{
		if( $_[0] ) { return $Cfg{'colBg3'}; }
		else
		{
			if( $ColorCnt++ % 2 ) { return $Cfg{'colBg1'}; }
			else { return $Cfg{'colBg2'}; }
		}
	}
}


sub ChgContent #( ڿ )
#*********************************************************************
# ġȯ
#---------------------------------------------------------------------
{
	#- <br>
	if( $Cfg{'enter'} ) { $_[0] =~ s/<br>/ /gi; }

	#-̹ũ 
	if( $Cfg{'delImgLink'}) { $_[0] =~ s/<img .+?>//gi; }

	#- ±׻
	if( $Cfg{'delTag'}) { $_[0] =~ s/<\w.+?>//gi; }

	if( $Cfg{'noHtml'} )
	{
		$_[0] =~ s/</&lt;/g;
		$_[0] =~ s/>/&gt;/g;
	}

	#- յ  
	if( $Cfg{'delSpace'})
	{
		$_[0] =~ s/^( |<p>|<br>)+(<p>|<br>)//gi;
		$_[0] =~ s/( |<p>|<br>)+$//gi;
	}

	#- ϸ
	if( $Cfg{'smiley'} && $Cont[$cSmil] )
	{
		$_[0] =~ s/($Smiley_Char)~/<img src=$IMG_PATH\/smiley\/gima0$Smiley_File{$1}.gif width=13 height=12 border=0 alt=$1~ align=top>/g if( $_[0] =~ /~/ );
		$_[0] =~ s/:($MiniPic_Char):/<img src=$IMG_PATH\/smiley\/gima0$MiniPic_File{$1}.gif width=13 height=12 border=0 align=top> /g if( $_[0] =~ /:/ );
	}

	#- ڵũ
	if( $Cfg{'autoLink'} && $Cont[$cLink] && !$Cont[$cHtml] )
	{
		my $A1 = "http:\\/\\/|ftp:\\/\\/|telnet:\\/\\/|mailto:|news:|www\\.";
		my $A2 = "\\w|\\/|\\?|~|-|=|_|@|&";

#		$_[0] =~ s/(&lt;(img|a) .[^;]+)($A1)(.[^;]+&gt;)/$1:$3:$4/gi;
#		$_[0] =~ s/(&lt;a .[^;]+&gt;\S*)($A1)(.[^;]+&lt;\/a&gt;)/$1:$2:$3/gi;
#		$_[0] =~ s/(<(img|a) .[^>]+)($A1)(.[^>]+>)/$1:$3:$4/gi;
#		$_[0] =~ s/(<a .[^>]+>\S*)($A1)(.[^>]+<\/a>)/$1:$2:$3/gi;

		$_[0] =~ s/(($A1)($A2)+(\.($A2)+)+)/<a href='$1' target='$Cfg{'target'}'>$1<\/a>/gi;
		$_[0] =~ s/href='www\./href='http:\/\/www\./gi;
#		$_[0] =~ s/:($A1):/$1/gi;
	}

	if( ($CMD{'key'} & 4) == 4 )
	{
		$_[0] =~ s/($CMD{'word'})/<font color='$Cfg{'linkColA'}'><b>$1<\/b><\/font>/gi;
	}

	if( $Cont[$cHtml] ) { &UrlDecode( $_[0] ); }
	else { $_[0] =~ s/  /&nbsp;&nbsp;/g; }
}


sub Add_InfoCount #( Խùȣ, ,  )
#*********************************************************************
# Խù īƮ 
#---------------------------------------------------------------------
{
	my $Te;
	my $T1;
	my $Offset = 4;

	$Offset += $_[1] * 4 if( $_[1] );

	fOpen( fp1, "$DB_PATH/index.dat", "br" );
	fOpen( fp2, "$DB_PATH/content.dat", "b+r" );

	$Te = fGet( fp1, $_[0] * 5 + 40, 4, "L" );
	$T1 = fGet( fp2, $Te + $Offset, 4, "I" );

	fPut( fp2, $Te + $Offset, ++$T1, "I" ) if( $_[2] eq "" );
	fPut( fp2, $Te + $Offset, $_[2], "I" ) if( $_[2] ne "" );

	fClose( fp1 );
	fClose( fp2, 1 );
}


sub PasswordBox
#*********************************************************************
# н Էȭ
#---------------------------------------------------------------------
{
	&HtmlHead;

	print "<form method=post name=pwform action='$BOARD_CGI'>\n";
	print "<input type=hidden name=db   value=$CMD{'db'}>\n";
	print "<input type=hidden name=act  value=$CMD{'act'}>\n";
	print "<input type=hidden name=num  value=$CMD{'num'}>\n";
	print "<input type=hidden name=page value=$CMD{'page'}>\n";

	&Prn_PasswordBox;
	&HtmlTail;
	exit;
}


sub Chk_Password
#*********************************************************************
# н üũ
#---------------------------------------------------------------------
{
	&PasswordBox( $_[0] ) unless( $CMD{'pw'} );
	&GetContent( $CMD{'num'}, 1 );
	&ErrMsg( "ȣ Ʋϴ." ) if( $CMD{'pw'} ne $Cont[$cPass] && $CMD{'pw'} ne &Get_AdminPW );
}


sub Chk_AdminPW
#*********************************************************************
# н üũ ()
#---------------------------------------------------------------------
{
	&PasswordBox( $_[0] ) unless( $CMD{'pw'} );
	&ErrMsg( "ȣ Ʋϴ." ) if( $CMD{'pw'} ne &Get_AdminPW );
}


sub Get_AdminPW
#*********************************************************************
#  н 
#---------------------------------------------------------------------
{
	if( open( Handle, "$DB_PATH/password.cgi" ) )
	{
		my $Te = <Handle>;
		close( Handle );
		return $Te;
	}
	else { &ErrMsg( "н  ã  ϴ." ); }
}


sub Make_PassFile
#*********************************************************************
# ʱ  н ϱ
#---------------------------------------------------------------------
{
	open ( Handle, ">$DB_PATH/password.cgi" );
	flock( Handle, 2 ) if( $OS );
	print( Handle "haCgJe9Bg9L7w" );
	close( Handle );
	flock( Handle, 8 ) if( $OS );
}


sub Prn_Btn4list
#*********************************************************************
# Ϻ ư
#---------------------------------------------------------------------
{
	return if( !$Cfg{'listBtn'} && $_[0] eq "dn" || $Cfg{'listBtn'} == 1 && $_[0] eq "up" );

	my( $StrPage, $EndPage ) = &GetPage;

	printf "<table width='%s' border=0 cellspacing=0 cellpadding=0>\n", $_[1]? $_[1]: $Cfg{'tblWidth'};
	print "  <tr><td colspan=3><hr size=1></td></tr>\n" if( $_[0] eq "dn" );
	print "  <tr>\n";
	print "    <td width=33% nowrap>\n";
	
	&Prn_Button( "Ȩ", "$Cfg{'returnPage'}", "home" ) if( $Cfg{'returnPage'} );
	&Prn_Button( "۾", "$BOARD_CGI?db=$CMD{'db'}&act=write&page=$CMD{'page'}", "write" );
	
	print "    </td>\n";
	print "    <td width=34% nowrap align=center>\n"; &Prn_FindForm; print " " x 4, "</td>\n";
	print "    <td width=33% nowrap align=right>\n";

	if( $CMD{'act'} eq "search" )
	{
		my $Te = "$BOARD_CGI?db=$CMD{'db'}&act=search&page=$CMD{'page'}&key=$CMD{'key'}&word=$CMD{'word'}";
		&Prn_Button( "", sprintf("$Te&spage=%d", $CMD{'spage'}-1), "prev" ) if( $CMD{'spage'} > 1 );
		&Prn_Button( "", sprintf("$Te&spage=%d", $CMD{'spage'}+1), "next" );
		&Prn_Button( "Ϻ", "$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}", "list" );
	}
	else
	{
		&Prn_Button( "ó", sprintf("$BOARD_CGI?db=$CMD{'db'}&page=%d", 1             ), "first" ) if( $CMD{'page'} > 1 );
		&Prn_Button( "", sprintf("$BOARD_CGI?db=$CMD{'db'}&page=%d", $CMD{'page'}-1), "prev"  ) if( $CMD{'page'} > $StrPage );
		&Prn_Button( "", sprintf("$BOARD_CGI?db=$CMD{'db'}&page=%d", $CMD{'page'}+1), "next"  ) if( $CMD{'page'} < $EndPage );
		&Prn_Button( ""  , sprintf("$BOARD_CGI?db=$CMD{'db'}&page=%d", $EndPage      ), "last"  ) if( $CMD{'page'} < $EndPage );
	}

	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr><td colspan=3><hr size=1></td></tr>\n" if( $_[0] eq "up" );
	print "</table>\n\n";
}


sub Prn_Btn4view
#*********************************************************************
#  ư
#---------------------------------------------------------------------
{
#	return if( $CMD{'act'} eq "pread" && $_[0] eq "up" );
	return if( !$Cfg{'readBtn'} && $_[0] eq "dn" || $Cfg{'readBtn'} == 1 && $_[0] eq "up" );

	print "<table width='$Cfg{'tblWidth'}' border=0 cellspacing=0 cellpadding=0>\n";
	print "  <tr>\n";
	print "    <td width=50%>\n";

	if( $CMD{'act'} eq "pread" ) { print "&nbsp;"; }
	else
	{
		&Prn_Button( ""  , "$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}&act=del&num=$CMD{'num'}", "delete" );
		&Prn_Button( "ϱ", "$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}&act=edit&num=$CMD{'num'}", "modify" );
		&Prn_Button( "ϱ", "$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}&act=reply&num=$CMD{'num'}", "reply" );
		&Prn_Button( "۾"  , "$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}&act=write", "write" );
	}

	print " " x 4, "</td>\n";
	print " " x 4, "<td width=50% align=right>\n";

	if( $CMD{'act'} eq "pread" )
	{
		&Prn_Button( "âݱ", "javascript:self.close()", "close" );
	}
	else
	{
		&Prn_Button( ""  , sprintf("$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}&act=read&num=%d", $PrevNum), "prev" ) if( $PrevNum );
		&Prn_Button( ""  , sprintf("$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}&act=read&num=%d", $NextNum), "next" ) if( $NextNum );
		&Prn_Button( "Ϻ", "$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}", "list" );
	}

	print "    </td>\n";
	print "  </tr>\n";
	print "</table>\n\n";
}


sub GetPrevNextNum
#*********************************************************************
#   ȣ 
#---------------------------------------------------------------------
{
	my $PrevNum;
	my $NextNum;

	if( $GetRangeOpt )
	{
		fOpen( FP1, "$DB_PATH/index.dat", "br" );

		for( my $i=$CMD{'num'}+1; $i<=$TotalCont; $i++ )
		{
			unless( ord( fGet( FP1, $i * 5 + 44, 1, "" )))
			{
				$PrevNum = $i;
				last;
			}
		}

		for( my $i=$CMD{'num'}-1; $i>=0; $i-- )
		{
			unless( ord( fGet( FP1, $i * 5 + 44, 1, "" )))
			{
				$NextNum = $i;
				last;
			}
		}
		close( FP1 );
	}

	else
	{
		$PrevNum = $CMD{'num'} + 1;
		$NextNum = $CMD{'num'} - 1;
		$PrevNum = 0 if( $PrevNum > $TotalCont );
	}

	return $PrevNum, $NextNum;
}


sub GetPrevSubj
#---------------------------------------------------------------------
{
	return if( $CMD{'act'} eq "pread" );

	if( $PrevNum  )
	{
		&GetContent( $PrevNum );
		return "<a href=$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}&act=read&num=$PrevNum><font color='$Cfg{'colSubj'}'> $Cont[$cSubj]</font></a><br>";
	}
	else { return "<br>"; }
}


sub GetNextSubj
#---------------------------------------------------------------------
{
	return if( $CMD{'act'} eq "pread" );

	if( $NextNum )
	{
		&GetContent( $NextNum );
		return "<a href=$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}&act=read&num=$NextNum><font color='$Cfg{'colSubj'}'> $Cont[$cSubj]</font></a><br>";
	}
	else { return "<br>"; }
}



sub Prn_Subject
#*********************************************************************
#  
#---------------------------------------------------------------------
{
	if( $CMD{'act'} eq "search" )
	{
		$Cont[$cSubj] =~ s{($SearchWord)}{<font color='$Cfg{'linkColA'}'><b>$1</b></font>}gi if( ($CMD{'key'} & 2) == 2 );

		print "<a href=\"javascript:PopWin('$BOARD_CGI?db=$CMD{'db'}&act=pread";
		print "&num=$_&key=$CMD{'key'}&word=$SearchWord')\">$Cont[$cSubj]</a>";
	}
	else
	{
		if( $CMD{'num'} == $Index[$ListCount-1] )
		{
			print "<font color='$Cfg{'linkColA'}'>$Cont[$cSubj]</font>";
		}
		else
		{
			print "<a href=$BOARD_CGI?db=$CMD{'db'}&act=read&page=$CMD{'page'}&num=$_>$Cont[$cSubj]</a>";
		}
	}
}



sub Prn_SubjLine
#*********************************************************************
#   ׸
#---------------------------------------------------------------------
{
	return if( $CMD{'act'} eq "search" );

	my $Te;
	my $Flag;
	my $NextDepth;
	my $Offset = $_[0];

	if( $Cfg{'subjLine'} )
	{
		for( 1..$Cont[0] )
		{
			$Te = $_[0];
			$Flag = 0;
			if( $_ == $Cont[0] )
			{
				do {
					$NextDepth = $Depth[++$Te];
					$Flag = 2 if( $NextDepth <  $_ );
					$Flag = 1 if( $NextDepth == $_ );
				} until( $NextDepth <= $_ );
			}
			else
			{
				do {
					$NextDepth = $Depth[++$Te];
					$Flag = 3 if( $NextDepth == $_ );
				} until( $NextDepth <= $_ );
			}
			$Te = "blank" unless( $Flag );
			$Te = "line$Flag" if( $Flag );
			print "<img src=$IMG_PATH/$Te.gif width=13 height=18 border=0 align=absmiddle>";
		}
	}
	else
	{
		for( 1..$Cont[0] ) { print ""; }
	}
}



sub Prn_SubjIcon
#*********************************************************************
#   
#---------------------------------------------------------------------
{
	my $Te;
	return unless( $Cfg{'subjIcon'} );

	if( $Cfg{'todayChk'} )
	{
		if( &GetDate(time,2) eq substr($Cont[$cDate],0,10) ) { $Te = "today"; }
		else { $Te = "subj"; }
	}
	else { $Te = "subj"; }

	print "<img src=$IMG_PATH/$Te.gif height=18 border=0 align=absmiddle> ";
}



sub Prn_PageMenu
#*********************************************************************
# ޴ 
#---------------------------------------------------------------------
{
	return unless( $Cfg{'pageMenu'} );

	my( $StrPage, $EndPage ) = &GetPage;
	my( $StrTemp, $EndTemp );
	my( $Prev ) = $CMD{'page'} - 10;
	my( $Next ) = $CMD{'page'} + 10;

	$Prev = 1 if( $Prev < 1 );
	$Next = $EndPage if( $Next > $EndPage );

	$StrTemp  = $CMD{'page'} - 4;
	$EndTemp  = $CMD{'page'} + 5;
	$EndTemp += 1 - $StrTemp if( $StrTemp < 1 );
	$StrTemp -= $EndTemp - $EndPage if( $EndPage < $EndTemp );
	$StrTemp  = 1 if( $StrTemp < 1 );
	$EndTemp  = $EndPage if( $EndPage < $EndTemp );

	print "\n";
	print "[<a href=$BOARD_CGI?db=$CMD{'db'}&page=$Prev></a>]\n..." if( $StrTemp > $StrPage );

	for( $StrTemp..$EndTemp )
	{
		if( $CMD{'page'} == $_ ) { print "<B>[<font color=red>$_</font>]</b>"; }
		else { print "[<a href=$BOARD_CGI?db=$CMD{'db'}&page=$_>$_</a>]"; }
		print "\n" unless( $_ == $EndTemp );
	}

	print "...\n[<a href=$BOARD_CGI?db=$CMD{'db'}&page=$Next></a>]" if( $EndTemp < $EndPage );
	print "<br>\n\n";
}



sub Prn_FindForm
#*********************************************************************
# ˻ 
#---------------------------------------------------------------------
{
	return unless( $Cfg{'findForm'} );
	$CMD{'key'} = 2 unless( $CMD{'word'} );

	print "<form name=findForm action='$BOARD_CGI' onSubmit='return ChkFindForm()'>\n";
	print "<input type=hidden name=db value='$CMD{'db'}'>\n";
	print "<input type=hidden name=act value='search'>\n";
	print "<input type=hidden name=page value='$CMD{'page'}'>\n\n";

	print "<table width=100% border=0 cellpadding=0 cellspacing=0>\n";
	print "  <tr><td align=center>\n";
	print "    <input type=checkbox name=key value=1", (($CMD{'key'} & 1) == 1)? " checked": "", "≯\n";
	print "    <input type=checkbox name=key value=2", (($CMD{'key'} & 2) == 2)? " checked": "", ">\n";
	print "    <input type=checkbox name=key value=4", (($CMD{'key'} & 4) == 4)? " checked": "", ">\n";
	print "  </td></tr>\n";
	print "  <tr><td align=center>\n";
	print "    <input type=text name=word value='$CMD{'word'}' size=16 class=input>\n";
	print "    <input type=submit value='˻' class=button>\n";
	print "  </td></tr></form>\n";
	print "</table>\n\n";
}



sub HtmlHead
#*********************************************************************
# Html 
#---------------------------------------------------------------------
{
	my $T1 = "color:$Cfg{'linkColH'}" if( $Cfg{'linkColH'} );
	my $T2 = "text-decoration:underline" if( $Cfg{'linkType'} );
	my $T3 = "font-family:$Cfg{'fontName'}" if( $Cfg{'fontName'} );
	my $T4 = "font-size:$Cfg{'fontSize'}pt" if( $Cfg{'fontSize'} );
	my $T5;

#.......................................
print <<"HtmlPrint";
Content-type: text/html\n
<!--------------------------------------------------------------------->
<!-- Blue Board 1.00                                                 -->
<!--                                                                 -->
<!--        Official distribution site : http://easynara.co.kr       -->
<!--                 Technical contact : help\@easynara.co.kr         -->
<!--                                                                 -->
<!--             Copyright (c) 2000-2002 EasyNara, Inc.              -->
<!--------------------------------------------------------------------->
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=euc-kr">
<title>$Cfg{'winTitle'}</title>
<style>
 a        { text-decoration:none; }
 a:hover  { $T1; $T2; }
 p,td     { $T3; $T4; }
 body     { $T3; $T4; }
 input    { $T3; $T4; }
 select   { $T3; $T4; border:solid; background-color:white; }
 textarea { $T3; $T4; border:1 solid; border-color:$Cfg{'colBg6'}; background-color:white; }
.text     { line-height:140%; }
.title    { color:blue; }
.nobod    { border:0; background-color:white; }
.input    { height:19px; border:1 solid; border-color:$Cfg{'colBg6'}; background-color:white; }
.button   { height:19px; border:1 solid; border-color:gray; background-color:$Cfg{'colBg6'}; border-width:1; color:$Cfg{'colSubj'}; }
.colNum   { color:$Cfg{'colNum'};  }
.colSubj  { color:$Cfg{'colSubj'}; }
.colName  { color:$Cfg{'colName'}; }
.colDate  { color:$Cfg{'colDate'}; }
.colInfo  { color:$Cfg{'colInfo'}; }
</style>
</head>

<script>
function PopWin( Url, Xsize, Ysize, Scroll )
{
    if( Xsize  == null ) Xsize  = 500
    if( Ysize  == null ) Ysize  = 400
    if( Scroll == null ) Scroll = 'yes'
    var opt = "width="+Xsize+",height="+Ysize+",scrollbars="+Scroll+",toolbar=no,location=no,directories=no,status=no,menubar=no,resizable=no,copyhistory=yes"
    window.open( Url, 'child', opt);
}

function ChkFindForm()
{
    if( !document.findForm.word.value )
    {
        alert( '˻ ž մϴ.' )
        return false
    }
}

function OnEnter( Obj ){ if( Obj.value == Obj.defaultValue ) Obj.value = '' }
function OnExit ( Obj ){ if( Obj.value == '' ) Obj.value = Obj.defaultValue }
</script>\n
HtmlPrint
#.......................................

	$T1 = "text='$Cfg{'bodFgCol'}'" if( $Cfg{'bodFgCol'} );
	$T2 = "bgcolor='$Cfg{'bodBgCol'}'" if( $Cfg{'bodBgCol'} );
	$T3 = "link='$Cfg{'linkCol'}' vlink='$Cfg{'linkCol'}'" if( $Cfg{'linkCol'} );
	$T4 = "alink='$Cfg{'linkColA'}'" if( $Cfg{'linkColA'} );
	$T5 = "backGround='$Cfg{'bodBgPic'}'" if( $Cfg{'bodBgPic'} );

	print "<body $T1 $T2 $T3 $T4 $T5>\n";
	printf "<div align=%s>\n", ($Cfg{'tblAlign'})? ($Cfg{'tblAlign'}==1)? "center": "right" :"left";
	print "$Cfg{'htmlHead'}\n" if( $CMD{'act'} !~ /In$/ && $CMD{'act'} ne "pread" );
}


sub HtmlTail
#*********************************************************************
# Html 
#---------------------------------------------------------------------
{
	print "$Cfg{'htmlTail'}\n" if( $CMD{'act'} !~ /In$/ && $CMD{'act'} ne "pread" );
	print "</div>\n";
	print "</body>\n";
	print "</html>\n";
}


sub ChkConfig
#*********************************************************************
# Config üŷ
#---------------------------------------------------------------------
{
	&SetRGB( $Cfg{'colBg1'}, $Cfg{'colBg2'} ) if( $Cfg{'colMode'} && $Cfg{'colBg1'} && $Cfg{'colBg2'} );

	$Cfg{'colBg4'} = &SetRGB( 0 ) if( $Cfg{'colBg4'} eq "auto" );
	$Cfg{'colBg5'} = &SetRGB( int( $Cfg{'pageLine'} / 2 )) if( $Cfg{'colBg5'} eq "auto" );
	$Cfg{'colBg6'} = &SetRGB( $Cfg{'pageLine'} ) if( $Cfg{'colBg6'} eq "auto" );

	$Cfg{'readList'} = $Cfg{'pageLine'} if( $Cfg{'readList'} > $Cfg{'pageLine'} );

	if( $CMD{'act'} eq "pread" )
	{
		$Cfg{'readList'} = 0;
		$Cfg{'pageMenu'} = 0;
		$Cfg{'tblWidth'} = "100%";
	}
	elsif( $CMD{'act'} eq "search" )
	{
		$Cfg{'pageMenu'} = 0;
	}

	if( !$Cfg{'colMode'} )
	{
		$Cfg{'colBg3'} = "" if( $Cfg{'colBg3'} =~ /auto/i );
		$Cfg{'colBg4'} = "" if( $Cfg{'colBg4'} =~ /auto/i );
		$Cfg{'colBg5'} = "" if( $Cfg{'colBg5'} =~ /auto/i );
		$Cfg{'colBg6'} = "" if( $Cfg{'colBg6'} =~ /auto/i );
	}
}
