sub GetParse
#*********************************************************************
# Ķ ¡
#---------------------------------------------------------------------
{
	if( $ENV{'QUERY_STRING'} )
	{
		@args = split( /&/, $ENV{'QUERY_STRING'} );

		foreach $pair( @args )
		{
			my( $Name, $Value ) = split(/=/, $pair);
			$Value =~ tr/+/ /;
			$Value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/ge;
			$Value =~ s/<!--(.|\n)*-->//g;
			$CMD{$Name} = $Value;
		}
	}

	else
	{
		my $content_type = $ENV{'CONTENT_TYPE'};
		my $content_len  = $ENV{'CONTENT_LENGTH'};

		binmode STDIN;
		read( STDIN, $buffer, $content_len );

		if( !$content_type || $content_type eq "application/x-www-form-urlencoded" )
		{
			@args = split( /&/, $buffer );
			$date = "";

			foreach $pair( @args )
			{
				my( $Name, $Value ) = split(/=/, $pair);
				$Value =~ tr/+/ /;
				$Value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/ge;
				$Value =~ s/<!--(.|\n)*-->//g;
				$CMD{$Name} = $Value;
			}
		}

		elsif( $content_type =~ m#^multipart/form-data# )
		{
			my @pairs;
			( $boundary = $content_type ) =~ s/^.*boundary=(.*)$/\1/;

			@pairs = split( /--$boundary/, $buffer );
			@pairs = splice( @pairs, 1, $#pairs-1 );

			for $part( @pairs )
			{
				my( $FileName, @columns );
				my( $dump, $fline, $value ) = split( /\r\n/, $part, 3 );

				if( $fline =~ /filename/ ) { $read_file = $fline; }
				next if $fline =~ /filename=\"\"/;

				$fline =~ s/^Content-Disposition: form-data; //;
				( @columns ) = split( /;\s+/, $fline );
				( $name = $columns[0] ) =~ s/^name="([^"]+)"$/\1/g;

				$FileName = $columns[1] if( $columns[1] =~ /filename=/ );
				$FileName =~ s/filename="([^"]+)"$/\1/g if( $FileName );

				if( $#columns > 0 )
				{
					if( $value =~ /^Content-Type:/ )
					{
						( $dump, $dump, $value ) = split( /\r\n/, $value, 3 );
					}
					else
					{
						( $dump, $value ) = split( /\r\n/, $value, 2 );
					}
				}
				else
				{
					( $dump, $value ) = split( /\r\n/, $value, 2 );
					if( grep( /^$names$/, keys( %CGI )))
					{
						if( @{$CMD{$name}} > 0 )
						{
							push( @{$CMD{$name}}, $value );
						}
						else
						{
							$arrvalue = $CMD{$name};
							undef $CMD{$name};
							$CMD{$name}[0] = $arrvalue;
							push( @{$CMD{$name}}, $value );
						}
					}
					else
					{
						next if $value =~ /^\s*$/;
						$CMD{$name} = $value;
						chop( $CMD{$name} );
						chop( $CMD{$name} );
					}
					next;
				}

				if( $FileName )
				{
					$FileName =~ s/^.+\\(.+)$/$1/g if( $FileName !~ /^http:\/\//i );
					$CMD{$name} = $FileName;
					$CMD{$name."_bin"} = $value;
				}
				else
				{
					$CMD{$name} = $value;
				}
			}
		}
	}
}



#********************************************************************
# ׶̼  Լ
#--------------------------------------------------------------------
sub SetRGB
{
	if( $_[1] ) #- 
	{
		($BaseRGB_[0], $BaseRGB_[1], $BaseRGB_[2]) = &RGB_Hex2Dec(lc($_[0]));
		($StepRGB_[0], $StepRGB_[1], $StepRGB_[2]) = &RGB_Hex2Dec(lc($_[1]));
		for( 0..2 ) { $StepRGB_[$_] -= $BaseRGB_[$_]; }
	}

	elsif( $_[0] eq "" ) #- 
	{
		my $Te = ( &RGB_Dec2Hex( $BaseRGB_[0], $BaseRGB_[1], $BaseRGB_[2] ));
		for( 0..2 ) { $BaseRGB_[$_] += $StepRGB_[$_]; }
		return $Te;
	}

	else #-  
	{
		my @Temp;
		for( 0..2 ) { $Temp[$_] = $BaseRGB_[$_] + $StepRGB_[$_] * $_[0]; }
		return( &RGB_Dec2Hex( $Temp[0], $Temp[1], $Temp[2] ) );
	}
}

# #ffffff¸ 255,255,255·
#--------------------------------------------------------------------
sub RGB_Hex2Dec
{
	my @a;
	for( 0..2 ) { $a[$_] = hex( substr($_[0], $_*2+1, 2) ); }
	return( $a[0], $a[1], $a[2] );
}

# 255,255,255¸ #ffffff·
#--------------------------------------------------------------------
sub RGB_Dec2Hex
{
	for( 0..2 )
	{
		if( $_[$_] > 255 ) { $_[$_] = 255; }
		elsif( $_[$_] < 0 ) { $_[$_] = 0; }
	}
	return sprintf( "#%02x%02x%02x", $_[0], $_[1], $_[2] );
}



sub ReadConfig
#*********************************************************************
# ȯ漳 ϰ
#---------------------------------------------------------------------
{
	my $Te;
	my $CfgFile = "$DB_PATH/config.cfg";
	   $CfgFile = "$LIB_PATH/default.cfg" unless( -e $CfgFile );

	if( open( Handle, $CfgFile ) )
	{
		while( $Te = <Handle> )
		{
			if( $Te !~ /^;/ && $Te !~ /^\s$/ )
			{
				$Te =~ s/\r|\n//g;
				my( $Name, $Value ) = split( /=/, $Te );
				$Name =~ s/^\s*//g;
				$Name =~ s/\s*$//g;
				$Value =~ s/^\s*'//g;
				$Value =~ s/'\s*$//g;
				$Cfg{$Name} = $Value;
				$Cfg{$Name} =~ s/&#61;/=/g;
				$Cfg{$Name} =~ s/\$\(cr\)/\n/g;
			}
		}
		close( Handle );
	}
	else
	{
		&ErrMsg( "$CfgFile   ϴ." );
	}
}



sub MakePW
#*********************************************************************
# н 
#---------------------------------------------------------------------
{
	my $Str = $_[0];
	return crypt( $Str, "happygima" );
}



sub ErrMsg #( ޽ )
#*********************************************************************
# ޽  
#---------------------------------------------------------------------
{
	&HtmlHead;
	&Prn_BoardTitle;

print <<"HtmlPrint";
<div align=center>
<table border=0 width=300 cellspacing=0>
  <tr>
    <td width=100% align=center><img src=$IMG_PATH/error1.gif border=0></td>
    <td rowspan=2><img src=$IMG_PATH/error2.gif border=0></td>
  <tr>
	<td align=center><font color='$Cfg{'colErr'}'>$_[0]</font></td>
  </tr>
  <tr>
    <td align=center colspan=2><br>[ <a href=javascript:history.back()>ȭ</a> ]</td>
  </tr>
</table>
</div>
HtmlPrint

#print <<"HtmlPrint";
#<table border=0 cellpadding=0 cellspacing=0 width=386 height=206 background='$IMG_PATH/error.gif'><tr><td>
#<div align=center><table border=0 cellpadding=0 cellspacing=0 width=50%>
#  <tr>
#    <td><font color='$Cfg{'colErr'}'>$_[0]<br><br></font></td>
#  </tr>
#  <tr>
#    <td>[ <a href="javascript:history.back()">ȭ</a> ]</td>
#  </tr>
#</table></div></td></tr>
#</table>
#HtmlPrint

	&HtmlLogo;
	&HtmlTail;
	exit;
}



sub Prn_PasswordBox
#*********************************************************************
# н Է¹ڽ 
#---------------------------------------------------------------------
{
	&Prn_BoardTitle;

print <<"HtmlPrint";
<div align=center>
<table width=350 border=0 cellpadding=4 cellspacing=0>
  <tr>
    <td rowspan=2><img src='$IMG_PATH/pass2.gif' border=0></td>
    <td valign=bottom>
      <font color=blue style='font-size:12'><b>$_[0]</b></font><p>
      <font color=maroon>ȣ Էϼ.</font>
	</td>
  </tr>
  <tr>
    <td valign=top><input type=password name=orgpw size=15 class=input>
    <input type=submit value='Ȯ' class=button></td>
  </tr></form>
  <tr>
    <td colspan=2 align=center>[ <a href=javascript:history.back()>ȭ</a> ]</td>
  </tr>
</table>
</div>

<script>
  document.pwform.orgpw.focus();
</script>\n
HtmlPrint

	&HtmlLogo;

#print <<"HtmlPrint";
#<table border=0 cellpadding=0 cellspacing=0 width=386 height=206 background='$IMG_PATH/password.gif'><tr><td>
#<div align=right><table border=0 cellpadding=0 cellspacing=0 width=50%>
#  <tr>
#    <td><font color="blue"><b>$_[0]</b></font><br><br></td>
#  </tr>
#  <tr>
#    <td><font color=maroon>ȣ Էϼ.</font></td>
#  </tr>
#  <tr>
#    <td>
#	  <input type=password name=orgpw size=10 class=input>
#      <input type=submit value=Ȯ class=button></td>
#  </tr>
#  <tr>
#    <td><p><br>[ <a href="javascript:history.back()">ȭ</a> ]</td>
#  </tr>
#</table></div></td></tr>
#</table>


}



sub HtmlLogo
#*********************************************************************
# Խ ϴ ΰ
#---------------------------------------------------------------------
{
	print "<table width=$Cfg{'tblWidth'} border=0 cellspacing=0>\n";
	print "  <tr>\n";
	print "    <td align=center><br><a href=http://easynara.co.kr target='$Cfg{'target'}'>";
	print "<font face= color='$Cfg{'colInfo'}'>Copyright(c)1999-2000 by Easynara, ";
	print "all right reserved</font></a></td>\n";
	print "  </tr>\n";
	print "</table>\n\n";
}



sub Java_GoNext
#*********************************************************************
# ڹ ũƮ GoNext
#---------------------------------------------------------------------
{
	$_[0] = "$BOARD_CGI?db=$CMD{'db'}&page=$CMD{'page'}" unless( $_[0] );
	print "Location:  $_[0]\n\n";

#	&HtmlHead;

#	print "<script>\n";
#	print "  function GoNext() { self.location.replace('$_[0]') }\n";
#	print "  setTimeout('GoNext()', 0)\n";
#	print "</script>\n\n";

#	&HtmlTail;
}



sub Prn_BoardTitle
#*********************************************************************
# Խ  
#---------------------------------------------------------------------
{
	return if( $CMD{'act'} eq "pread" );

	if( $Cfg{'bodTitle'} )
	{
		printf "<table width='%s' border=0 cellspacing=0>\n", $_[0]? $_[0]: $Cfg{'tblWidth'};
		print "  <tr><td align=center>";

		if( $Cfg{'bodPic'} ) { print "<img src='$Cfg{'bodPic'}' border=0>"; }
		else { print "<font style='font-size:18;'><b>$Cfg{'bodTitle'}</b></font>"; }

		print "</td></tr>\n";
		print "  <tr><td>&nbsp;</td></tr>\n";
		print "</table>\n\n";
	}
}



sub fOpen( *;@ )
#********************************************************************
#
#--------------------------------------------------------------------
{
	my( $Handle, $fFile, $fMode ) = @_;

	if( $fMode eq "r" ) {
		open( $Handle, "<$fFile" ); }
	
	elsif( $fMode eq "w" ) {
		open( $Handle, ">$fFile" );
		flock( $Handle, 2 ) if( $OS ); }

	elsif( $fMode eq "br" ) {
		open( $Handle, "<$fFile" );
		binmode( $Handle ); }

	elsif( $fMode eq "b+r" ) {
		open( $Handle, "+<$fFile" );
		flock( $Handle, 2 ) if( $OS );
		binmode( $Handle );
		seek( $Handle, 0, 0 ); }

	elsif( $fMode eq "bw" ) {
		open( $Handle, ">$fFile" );
		flock( $Handle, 2 ) if( $OS );
		binmode( $Handle );
		seek( $Handle, 0, 0 ); }
}


sub fClose( *;@ )
{
	my( $Handle, $fLock ) = @_;
	close( $Handle );

	if( $fLock ) {
		flock( $Handle, 8 ) if( $OS ); }
}


sub fGet( *;@ )
{
	my( $Te );
	my( $Handle, $Offset, $fSize, $fPack ) = @_;
	seek( $Handle, $Offset, 0 ) if( $Offset > -1 );
	read( $Handle, $Te, $fSize );
	if( $fPack eq "" ) { return $Te; }
	else { return unpack( $fPack, $Te ); }
}


sub fPut( *;@ )
{
	my( $Te );
	my( $Handle, $Offset, $fChar, $fPack ) = @_;
	seek( $Handle, $Offset, 0 ) if( $Offset > -1 );
	if( $fPack eq "" ) { print $Handle $fChar; }
	else { print $Handle pack( "$fPack", $fChar ); }
}


#*********************************************************************
return 1;